SystemOrganization addCategory: #'Mustache-Tests'!

TestCase subclass: #MustacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:47'!
getStash
| a b c |
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
a name:'Jesus Mar'.
a profession:'engineer'.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
b name:'caco'.
c job:'Singer'.
c name:'coca'.
a experience: (Array with:b with:c).
^a! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:43'!
testEmptySection

self assert:  ((Mustache toHtml:MustacheTest22 view:self getStash) = 'Empty Section test
Hello Jesus Mar
you work as a engineer
Ops!!
') .! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:00'!
testEmptyTemplate
self assert:((Mustache toHtml:MustacheTest0 view:self getStash) = 'Jesus Mar')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:58'!
testEmptyVariable

self assert:((Mustache toHtml:MustacheTest11 view:self getStash) = 'Simple test

Hello Jesus Mar
you work as a engineer
Your salary is $!!')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:46'!
testOuterContext

self assert:((Mustache toHtml:MustacheTest4 view:self getStash) = 'Non Empty List test outer content access

Jesus Mar
Jesus Mar--->Electrician
Jesus Mar--->Singer

')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:48'!
testOuterContextSameVariableInnerContext

self assert:((Mustache toHtml:MustacheTest4 view:self getStash) = 'Non Empty List test outer content access

Jesus Mar
caco--->Electrician
coca--->Singer

')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:11'!
testSection

self assert:((Mustache toHtml:MustacheTest2 view:self getStash) = 'Section test
Hello Jesus Mar
you work as a engineer
*Electrician;*Singer;
')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:55'!
testVariable

self assert:((Mustache toHtml:MustacheTest1 view:self getStash) = 'Simple test

Hello Jesus Mar
you work as a engineer')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:04'!
testVariableEscapedNonEscape

self assert:((Mustache toHtml:MustacheTest3 view:self getStash) = 'Escaped/non escaped test

*Jesus Mar
*engineer
*&lt;b&gt;Tirme&lt;/b&gt;
*<b>Tirme</b>
')! !

MuSTemplate subclass: #MuSTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MuSTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/21/2013 15:32'!
renderContentOn:html
html heading:'Simple test'.
html paragraph:('Hello ' , (html mustache variable:'name')).
html paragraph:('you work as a ' , (html mustache variable:'profession'))
! !

Object subclass: #MustacheTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTestRunner classSide methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 13:30'!
testCompileFile:aName
| mustache a tmp b c d |

a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
d:=JsonObject new.
a name:'Jesus Mar'.
d name:' alias "Jon".'.
a person:d.
a profession:'shift leader'.
a salary:2500.
a wrapped: [[:v :s| |retorno calc inner|
		"get the content"
		inner:= Mustache render: v asString view:s.
		retorno:='salary 13% of: ', inner.
		calc := ((s salary )- ((s salary) * 13 / 100)) asFloat .
		retorno := retorno , calc asString, ' Euros'.
		]] .
a inCa:true.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
c job:'Singer'.
a experience: (Array with:b with:c).
a repo: Array new.
a funcion:[ 1*2*3*4 *100].

mustache:= Mustache instanceFromFolder: 'D:\smalltalk\SCouchViewServer\templates\'.
tmp:= mustache renderTemplateAt: aName view: a. 
Transcript show: tmp.
! !

!MustacheTestRunner classSide methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 14:02'!
testCompileTemplate:aTemplate
"run in workspace:   MustacheTestRunner testCompileTemplate: MustacheTestX"
| aStream a tmp b c d |
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
d:=JsonObject new.
a name:'Jesus Mar'.
d name:' alias "Jon".'.
d funcion:[:ds|ds name].
a person:d.
a profession:'shift leader'.
a salary:2500.
a wrapped: [[:v :s| |retorno calc inner|
		"get the content"
		inner:= Mustache render: v asString view:s partials:self partials.
		retorno:='salary 13% of: ', inner.
		calc := ((s salary )- ((s salary) * 13 / 100)) asFloat .
		retorno := retorno , calc asString, ' Euros'.
		]] .
a inCa:true.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
c job:'Singer'.
a experience: (Array with:b with:c).
a repo: Array new.
a funcion:[ :stash| (stash salary * 0.9) asString , ' Euros' ].

tmp:= Mustache render: aTemplate view:a.
Transcript show: tmp.


! !

!MustacheTestRunner methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:26'!
seeClassSide! !

MustacheTemplate subclass: #MustacheTest0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest0 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:58'!
render
^'{{name}}'! !

MustacheTemplate subclass: #MustacheTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:14'!
render
	"return an Template within a string"

^'Simple test

Hello {{name}}
you work as a {{profession}}'! !

MustacheTemplate subclass: #MustacheTest11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest11 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:57'!
render
	"return an Template within a string"

^'Simple test

Hello {{name}}
you work as a {{profession}}
Your salary is ${{salary}}!!'! !

MustacheTemplate subclass: #MustacheTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest2 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:10'!
render
	"return an Template within a string"

^'Section test
Hello {{name}}
you work as a {{profession}}
{{#experience}}*{{job}};{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest22
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest22 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:41'!
render
	"return an Template within a string"

^'Empty Section test
Hello {{name}}
you work as a {{profession}}
{{#expe}}*{{job}};{{/expe}}
{{^expe}}Ops!!{{/expe}}
'! !

MustacheTemplate subclass: #MustacheTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:15'!
render
	"return an Template within a string"

^'Escaped/non escaped test

*{{name}}
*{{profession}}
*{{company}}
*{{{company}}}
'! !

MustacheTemplate subclass: #MustacheTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest4 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 21:06'!
render
	"return an Template within a string"

^'Non Empty List test outer content access

{{name}}
{{#experience}}
{{experience.name}}--->{{job}}
{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest5 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:01'!
render
	"return an Template within a string"

^'Lambdas test

Name:{{name}}, Profession:{{profession}}
Working at:{{company}}
------------------------------------------
Experience
{{#experience}}
{{job}}
{{[
	buffer nextPutAll:''How are you''.	
	]}}
{{/experience}}
------------------------------------------
Salary:
{{#wrapped}}
{{salary}}
{{/wrapped}}

'! !

MustacheTemplate subclass: #MustacheTest6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest6 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/17/2012 20:27'!
render
	"return an Template within a string"

^'Non False Values Test

Hash:
{
	"person" :{"name": "Jon"}
}

Template:
{{#person}}
Hi {{name}}!!
{{/person}}
'! !

MustacheTemplate subclass: #MustacheTest7
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest7 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 10:04'!
render
	"return an Template within a string"

^'Inverted Section Test

Hash:
{
	"repo":[]
}

{{#repo}}
	<b>{{name}}</b>
{{/repo}}
{{^repo}}
	No repos :(
{{/repo}}
'! !

MustacheTemplate subclass: #MustacheTest8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest8 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:56'!
render
	"return an Template within a string"

^'Comments Test

<h1>Today{{!! a comment 

is an strange world}} is Monday!!</h1>

Lambdas test

Name:{{name}}, Profession:{{profession}}
Working at:{{company}}
------------------------------------------
Experience
{{#experience}}
{{job}}
{{/experience}}
------------------------------------------
Salary:
{{#wrapped}}
{{>Partial1}}
{{/wrapped}}
'! !

MustacheTest8 subclass: #Partial1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!Partial1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:19'!
render
^'{{salary}}'! !

MustacheTest8 subclass: #Partial2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

MustacheTemplate subclass: #MustacheTest9
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest9 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:18'!
render
	"return an Template within a string"

^'Set Delimiters Test

* {{default_tags}}
{{=<% %>=}}
* <% erb_style_tags %>
<%={{ }}=%>
*{{default_tags_again}}
'! !
